<template>
    <div>
        <v-row justify="center">
            <v-col cols="6">
                <v-card>
                    <v-card-title>{{ $t('currency_rate') }}</v-card-title>
                    <v-skeleton-loader
                        :loading="loading"
                        height="320"
                        type="card, actions"
                    >
                        <v-card-text class="pb-0">
                            <ValidationObserver ref="observer" v-slot="{ validate, reset }" slim>
                                <template v-for="rate in currencyRate">
                                    <div class="d-flex flex-row flex-nowrap">
                                        <v-col cols="6">
                                            <v-subheader>{{ $t(rate.key) }}</v-subheader>
                                        </v-col>
                                        <ValidationProvider v-slot="{ errors }" :name="$t(rate.key)" rules="required|decimal:4">
                                            <v-col>
                                                <v-text-field
                                                    v-model="rate.value"
                                                    :error-messages="errors"
                                                    type="number"
                                                    min="0.01"
                                                    hide-details="auto"
                                                    outlined
                                                >
                                                </v-text-field>
                                            </v-col>
                                        </ValidationProvider>
                                    </div>
                                </template>
                            </ValidationObserver>
                        </v-card-text>
                        <v-card-actions class="pa-5 justify-center">
                            <v-btn class="primary px-5"
                                   :loading="rateUpdate"
                                   @click="updateCurrencyRate"
                                   large
                            >
                                <v-icon left>mdi-content-save</v-icon>
                                {{ $t('save') }}
                            </v-btn>
                        </v-card-actions>
                    </v-skeleton-loader>
                </v-card>
            </v-col>

            <v-snackbar
                v-model="snackbar.show"
                :color="snackbar.color"
                :timeout="snackbar.timeout"
                absolute
            >
                {{ snackbar.message }}

                <template v-slot:action="{ attrs }">
                    <v-btn
                        icon
                        color="white"
                        v-bind="attrs"
                        @click="snackbar.show = false"
                    >
                        <v-icon>close</v-icon>
                    </v-btn>
                </template>
            </v-snackbar>
        </v-row>
    </div>
</template>

<script>
    import { ValidationObserver, ValidationProvider } from 'vee-validate';

    export default {
        name: "Setting",
        components: {ValidationObserver, ValidationProvider},

        data: () => ({
            loading: true,
            settings: [],
            rateUpdate: false,
            snackbar: {
                show: false,
                color: null,
                timeout: 6000,
                message: ''
            }
        }),

        mounted() {
            this.getSettings();
        },

        computed: {
            currencyRate() {
                return this.settings.filter(s => s.key.includes('currencies.rate'));
            }
        },

        methods: {
            getSettings() {
                axios.get('api/settings')
                    .then(({ data }) => {
                        this.settings = data;
                        this.loading = false;
                    })
            },

            updateCurrencyRate() {
                this.rateUpdate = true;

                this.$refs.observer.validate()
                    .then(valid => {
                        if(valid) {
                            axios.post('api/settings', {
                                settings: this.currencyRate
                            })
                                .then(({ data }) => {
                                    this.rateUpdate = false;
                                    if(data) {
                                        this.snackbar.show = true;
                                        this.snackbar.color = 'success';
                                        this.snackbar.message = this.$t('update_setting_success');
                                    }
                                })
                                .catch(error => {
                                    this.rateUpdate = false;
                                })
                        }
                        else {
                            this.rateUpdate = false;
                        }
                    })
            }
        }
    }
</script>

<style scoped>
</style>
